/usr/share/cluster/utils/fs-lib.sh is in resource-agents 1:4.0.0~rc1-4.
This file is owned by root:root, with mode 0o755.
The actual contents of the file can be viewed below.
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270 271 272 273 274 275 276 277 278 279 280 281 282 283 284 285 286 287 288 289 290 291 292 293 294 295 296 297 298 299 300 301 302 303 304 305 306 307 308 309 310 311 312 313 314 315 316 317 318 319 320 321 322 323 324 325 326 327 328 329 330 331 332 333 334 335 336 337 338 339 340 341 342 343 344 345 346 347 348 349 350 351 352 353 354 355 356 357 358 359 360 361 362 363 364 365 366 367 368 369 370 371 372 373 374 375 376 377 378 379 380 381 382 383 384 385 386 387 388 389 390 391 392 393 394 395 396 397 398 399 400 401 402 403 404 405 406 407 408 409 410 411 412 413 414 415 416 417 418 419 420 421 422 423 424 425 426 427 428 429 430 431 432 433 434 435 436 437 438 439 440 441 442 443 444 445 446 447 448 449 450 451 452 453 454 455 456 457 458 459 460 461 462 463 464 465 466 467 468 469 470 471 472 473 474 475 476 477 478 479 480 481 482 483 484 485 486 487 488 489 490 491 492 493 494 495 496 497 498 499 500 501 502 503 504 505 506 507 508 509 510 511 512 513 514 515 516 517 518 519 520 521 522 523 524 525 526 527 528 529 530 531 532 533 534 535 536 537 538 539 540 541 542 543 544 545 546 547 548 549 550 551 552 553 554 555 556 557 558 559 560 561 562 563 564 565 566 567 568 569 570 571 572 573 574 575 576 577 578 579 580 581 582 583 584 585 586 587 588 589 590 591 592 593 594 595 596 597 598 599 600 601 602 603 604 605 606 607 608 609 610 611 612 613 614 615 616 617 618 619 620 621 622 623 624 625 626 627 628 629 630 631 632 633 634 635 636 637 638 639 640 641 642 643 644 645 646 647 648 649 650 651 652 653 654 655 656 657 658 659 660 661 662 663 664 665 666 667 668 669 670 671 672 673 674 675 676 677 678 679 680 681 682 683 684 685 686 687 688 689 690 691 692 693 694 695 696 697 698 699 700 701 702 703 704 705 706 707 708 709 710 711 712 713 714 715 716 717 718 719 720 721 722 723 724 725 726 727 728 729 730 731 732 733 734 735 736 737 738 739 740 741 742 743 744 745 746 747 748 749 750 751 752 753 754 755 756 757 758 759 760 761 762 763 764 765 766 767 768 769 770 771 772 773 774 775 776 777 778 779 780 781 782 783 784 785 786 787 788 789 790 791 792 793 794 795 796 797 798 799 800 801 802 803 804 805 806 807 808 809 810 811 812 813 814 815 816 817 818 819 820 821 822 823 824 825 826 827 828 829 830 831 832 833 834 835 836 837 838 839 840 841 842 843 844 845 846 847 848 849 850 851 852 853 854 855 856 857 858 859 860 861 862 863 864 865 866 867 868 869 870 871 872 873 874 875 876 877 878 879 880 881 882 883 884 885 886 887 888 889 890 891 892 893 894 895 896 897 898 899 900 901 902 903 904 905 906 907 908 909 910 911 912 913 914 915 916 917 918 919 920 921 922 923 924 925 926 927 928 929 930 931 932 933 934 935 936 937 938 939 940 941 942 943 944 945 946 947 948 949 950 951 952 953 954 955 956 957 958 959 960 961 962 963 964 965 966 967 968 969 970 971 972 973 974 975 976 977 978 979 980 981 982 983 984 985 986 987 988 989 990 991 992 993 994 995 996 997 998 999 1000 1001 1002 1003 1004 1005 1006 1007 1008 1009 1010 1011 1012 1013 1014 1015 1016 1017 1018 1019 1020 1021 1022 1023 1024 1025 1026 1027 1028 1029 1030 1031 1032 1033 1034 1035 1036 1037 1038 1039 1040 1041 1042 1043 1044 1045 1046 1047 1048 1049 1050 1051 1052 1053 1054 1055 1056 1057 1058 1059 1060 1061 1062 1063 1064 1065 1066 1067 1068 1069 1070 1071 1072 1073 1074 1075 1076 1077 1078 1079 1080 1081 1082 1083 1084 1085 1086 1087 1088 1089 1090 1091 1092 1093 1094 1095 1096 1097 1098 1099 1100 1101 1102 1103 1104 1105 1106 1107 1108 1109 1110 1111 1112 1113 1114 1115 1116 1117 1118 1119 1120 1121 1122 1123 1124 1125 1126 1127 1128 1129 1130 1131 1132 1133 1134 1135 1136 1137 1138 1139 1140 1141 1142 1143 1144 1145 1146 1147 1148 1149 1150 1151 1152 1153 1154 1155 1156 1157 1158 1159 1160 1161 1162 1163 1164 1165 1166 1167 1168 1169 1170 1171 1172 1173 1174 1175 1176 1177 1178 1179 1180 1181 1182 1183 1184 1185 1186 1187 1188 1189 1190 1191 1192 1193 1194 1195 1196 1197 1198 1199 1200 1201 1202 1203 1204 1205 1206 1207 1208 1209 1210 1211 1212 1213 1214 1215 1216 1217 1218 1219 1220 1221 1222 1223 1224 1225 1226 1227 1228 1229 | #!/bin/bash
#
# Copyright (C) 1997-2003 Sistina Software, Inc. All rights reserved.
# Copyright (C) 2004-2011 Red Hat, Inc. All rights reserved.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
#
# File system common functions
#
LC_ALL=C
LANG=C
PATH=/bin:/sbin:/usr/bin:/usr/sbin
export LC_ALL LANG PATH
# Define this value to 0 by default, bind-mount.sh or any other agent
# that uses this value will alter it after sourcing fs-lib.sh
export IS_BIND_MOUNT=0
# Private return codes
FAIL=2
NO=1
YES=0
YES_STR="yes"
[ -z "$OCF_RESOURCE_INSTANCE" ] && export OCF_RESOURCE_INSTANCE="filesystem:$OCF_RESKEY_name"
#
# Using a global to contain the return value saves
# clone() operations. This is important to reduce
# resource consumption during status checks.
#
# There is no way to return a string from a function
# in bash without cloning the process, which is exactly
# what we are trying to avoid. So, we have to resort
# to using a dedicated global variables.
declare REAL_DEVICE
declare STRIP_SLASHES=""
declare FINDMNT_OUTPUT=""
#
# Stub ocf_log function for when we are using
# quick_status, since ocf_log generally forks (and
# sourcing ocf-shellfuncs forks -a lot-).
#
ocf_log()
{
echo $*
}
#
# Assume NFS_TRICKS are not available until we are
# proved otherwise.
#
export NFS_TRICKS=1
#
# Quick status doesn't fork() or clone() when using
# device files directly. (i.e. not symlinks, LABEL= or
# UUID=
#
if [ "$1" = "status" -o "$1" = "monitor" ] &&
[ "$OCF_RESKEY_quick_status" = "1" ]; then
echo Using Quick Status
# XXX maybe we can make ocf-shellfuncs have a 'quick' mode too?
export OCF_SUCCESS=0
export OCF_ERR_GENERIC=1
else
#
# Grab nfs lock tricks if available
#
if [ -f "$(dirname $0)/svclib_nfslock" ]; then
. $(dirname $0)/svclib_nfslock
NFS_TRICKS=0
fi
. $(dirname $0)/ocf-shellfuncs
fi
verify_name()
{
if [ -z "$OCF_RESKEY_name" ]; then
ocf_log err "No file system name specified."
return $OCF_ERR_ARGS
fi
return $OCF_SUCCESS
}
verify_mountpoint()
{
if [ -z "$OCF_RESKEY_mountpoint" ]; then
ocf_log err "No mount point specified."
return $OCF_ERR_ARGS
fi
if ! [ -e "$OCF_RESKEY_mountpoint" ]; then
ocf_log info "Mount point $OCF_RESKEY_mountpoint will be "\
"created at mount time."
return $OCF_SUCCESS
fi
[ -d "$OCF_RESKEY_mountpoint" ] && return $OCF_SUCCESS
ocf_log err "$OCF_RESKEY_mountpoint exists but is not a directory."
return $OCF_ERR_ARGS
}
#
# This used to be called using $(...), but doing this causes bash
# to set up a pipe and clone(). So, the output of this function is
# stored in the global variable REAL_DEVICE, declared previously.
#
real_device()
{
declare dev="$1"
declare realdev
if [ $IS_BIND_MOUNT -eq 1 ]; then
REAL_DEVICE="$dev"
return $OCF_SUCCESS
fi
REAL_DEVICE=""
[ -z "$dev" ] && return $OCF_ERR_ARGS
# Oops, we have a link. Sorry, this is going to fork.
if [ -h "$dev" ]; then
realdev=$(readlink -f $dev)
if [ $? -ne 0 ]; then
return $OCF_ERR_ARGS
fi
REAL_DEVICE="$realdev"
return $OCF_SUCCESS
fi
# If our provided blockdev is a device, we are done
if [ -b "$dev" ]; then
REAL_DEVICE="$dev"
return $OCF_SUCCESS
fi
# It's not a link, it's not a block device. If it also
# does not match UUID= or LABEL=, then findfs is not
# going to find anything useful, so we should quit now.
if [ "${dev/UUID=/}" = "$dev" ] &&
[ "${dev/LABEL=/}" = "$dev" ]; then
return $OCF_ERR_GENERIC
fi
# When using LABEL= or UUID=, we can't save a fork.
realdev=$(findfs "$dev" 2> /dev/null)
if [ -n "$realdev" ] && [ -b "$realdev" ]; then
REAL_DEVICE="$realdev"
return $OCF_SUCCESS
fi
return $OCF_ERR_GENERIC
}
verify_device()
{
declare realdev
if [ -z "$OCF_RESKEY_device" ]; then
ocf_log err "No device or label specified."
return $OCF_ERR_ARGS
fi
real_device "$OCF_RESKEY_device"
realdev="$REAL_DEVICE"
if [ -n "$realdev" ]; then
if [ "$realdev" != "$OCF_RESKEY_device" ]; then
ocf_log info "Specified $OCF_RESKEY_device maps to $realdev"
fi
return $OCF_SUCCESS
fi
ocf_log err "Device or label \"$OCF_RESKEY_device\" not valid"
return $OCF_ERR_ARGS
}
list_mounts()
{
if [ $IS_BIND_MOUNT -eq 1 ]; then
cat /etc/mtab
else
cat /proc/mounts
fi
}
##
# Tries to use findmnt util to return list
# of mountpoints for a device
#
# Global variables are used to reduce forking when capturing stdout.
#
# Return values
# 0 - device mount points found, mountpoint list returned to FINDMNT_OUTPUT global variable
# 1 - device mount not found
# 2 - findmnt tool isn't found or can not be used
#
##
try_findmnt()
{
FINDMNT_OUTPUT=""
case $OCF_RESKEY_use_findmnt in
0|false|no|off)
return 2 ;;
*)
: ;;
esac
which findmnt > /dev/null 2>&1
if [ $? -eq 0 ]; then
FINDMNT_OUTPUT="$(findmnt -o TARGET --noheadings $1)"
if [ $? -ne 0 ]; then
# workaround mount helpers inconsistency that still
# add / on the device entry in /proc/mounts
FINDMNT_OUTPUT="$(findmnt -o TARGET --noheadings $1/)"
if [ $? -ne 0 ]; then
return 1
else
return 0
fi
else
return 0
fi
fi
return 2
}
##
# Returns result in global variable to reduce forking
##
strip_trailing_slashes()
{
local tmp=$1
while [ "${tmp#${tmp%?}}" = "/" ]
do
tmp="${tmp%/}"
done
STRIP_SLASHES="$tmp"
}
#
# kill_procs_using_mount mount_point [signal]
#
# Kill any processes using the specified mountpoint, using the optional
# specified signal. This is used in place of fuser to avoid it becoming
# blocked while following symlinks to an unresponsive file system.
# Defaults to SIGKILL if no signal specified.
#
kill_procs_using_mount () {
declare mp
declare procs
declare mmap_procs
if [ $# -lt 1 -o -z "$1" ]; then
ocf_log err "Usage: kill_procs_using_mount mount_point [signal]"
return $FAIL
fi
strip_trailing_slashes "$1"
mp="$STRIP_SLASHES"
if [ -z "$mp" ]; then
ocf_log err "Usage: kill_procs_using_mount mount_point [signal]"
return $FAIL
fi
# anything held open in mount point after the slash
procs=$(find /proc/[0-9]*/ -type l -lname "${mp}/*" -or -lname "${mp}" 2>/dev/null | awk -F/ '{print $3}' | uniq)
# anything with memory mapping to something in the mountpoint
mmap_procs=$(grep " ${mp}" /proc/[0-9]*/maps | awk -F/ '{print $3}' | uniq)
procs=$(echo -e "${procs}\n${mmap_procs}" | sort | uniq)
for pid in $procs; do
if [ -n "$2" ]; then
kill -s $2 $pid
else
kill -s KILL $pid
fi
done
return $SUCCESS
}
#
# mount_in_use device mount_point
#
# Check to see if either the device or mount point are in use anywhere on
# the system. It is not required that the device be mounted on the named
# moint point, just if either are in use.
#
mount_in_use () {
declare mp tmp_mp
declare tmp_type
declare dev tmp_dev
declare junkb junkc junkd
declare res=$FAIL
declare findmnt_res=2
if [ $# -ne 2 ]; then
ocf_log err "Usage: mount_in_use device mount_point".
return $FAIL
fi
dev="$1"
mp="$2"
# First try and find out if the device has a mount point by
# attempting to use the findmnt tool. It is much faster than
# iterating through /proc/mounts
try_findmnt $dev
findmnt_res=$?
if [ $findmnt_res -eq 0 ]; then
case $OCF_RESKEY_fstype in
cifs|nfs|nfs4)
# -r means to include '/' character and not treat it as escape character
while read -r tmp_mp
do
if [ "$tmp_mp" = "$mp" ]; then
return $YES
fi
done < <(echo "$FINDMNT_OUTPUT")
;;
*)
return $YES
;;
esac
fi
while read -r tmp_dev tmp_mp tmp_type junkb junkc junkd; do
if [ "$tmp_type" = "autofs" ]; then
continue
fi
# Does the device match? We might have already tried findmnt
# which is why this could get skipped
if [ $findmnt_res -eq 2 ]; then
if [ "${tmp_dev:0:1}" != "-" ]; then
# XXX fork/clone warning XXX
tmp_dev="$(printf "$tmp_dev")"
fi
strip_trailing_slashes "$tmp_dev"
tmp_dev="$STRIP_SLASHES"
if [ -n "$tmp_dev" -a "$tmp_dev" = "$dev" ]; then
case $OCF_RESKEY_fstype in
cifs|nfs|nfs4)
;;
*)
return $YES
;;
esac
fi
fi
# Mountpoint from /proc/mounts containing spaces will
# have spaces represented in octal. printf takes care
# of this for us.
tmp_mp="$(printf "$tmp_mp")"
if [ -n "$tmp_mp" -a "$tmp_mp" = "$mp" ]; then
return $YES
fi
done < <(list_mounts)
return $NO
}
##
# Returns whether or not the device is mounted.
# If the mountpoint does not match the one provided, the
# mount point found is printed to stdout.
##
real_mountpoint()
{
declare dev=$1
declare mp=$2
declare ret=$NO
declare tmp_mp
declare tmp_dev
declare tmp_type
declare found=1
declare poss_mp=""
try_findmnt $dev
case $? in
0) #findmnt found mount points, loop through them to find a match
# -r means to include '/' character and not treat it as escape character
while read -r tmp_mp
do
ret=$YES
if [ "$tmp_mp" != "$mp" ]; then
poss_mp=$tmp_mp
else
found=0
break
fi
done < <(echo "$FINDMNT_OUTPUT")
;;
1)
# findmnt found no mount points for the device
return $NO
;;
2) # findmnt tool could not be used.
# Using slow method reading /proc/mounts dir.
while read -r tmp_dev tmp_mp tmp_type junk_b junk_c junk_d
do
if [ "$tmp_type" = "autofs" ]; then
continue
fi
if [ "${tmp_dev:0:1}" != "-" ]; then
# XXX fork/clone warning XXX
tmp_dev="$(printf "$tmp_dev")"
fi
# CIFS mounts can sometimes have trailing slashes
# in their first field in /proc/mounts, so strip them.
strip_trailing_slashes "$tmp_dev"
tmp_dev="$STRIP_SLASHES"
real_device "$tmp_dev"
tmp_dev="$REAL_DEVICE"
# XXX fork/clone warning XXX
# Mountpoint from /proc/mounts containing spaces will
# have spaces represented in octal. printf takes care
# of this for us.
tmp_mp="$(printf "$tmp_mp")"
if [ -n "$tmp_dev" -a "$tmp_dev" = "$dev" ]; then
ret=$YES
#
# Check to see if its mounted in the right
# place
#
if [ -n "$tmp_mp" ]; then
if [ "$tmp_mp" != "$mp" ]; then
poss_mp=$tmp_mp
else
found=0
break
fi
fi
fi
done < <(list_mounts)
esac
if [ $found -ne 0 ]; then
echo "$poss_mp"
fi
return $ret
}
#
# is_mounted device mount_point
#
# Check to see if the device is mounted. Print a warning if its not
# mounted on the directory we expect it to be mounted on.
#
is_mounted () {
declare mp
declare dev
declare ret=$FAIL
declare poss_mp
if [ $# -ne 2 ]; then
ocf_log err "Usage: is_mounted device mount_point"
return $FAIL
fi
real_device "$1"
dev="$REAL_DEVICE"
if [ -z "$dev" ]; then
ocf_log err "$OCF_RESOURCE_INSTANCE: is_mounted: Could not match $1 with a real device"
return $OCF_ERR_ARGS
fi
if [ -h "$2" ]; then
mp="$(readlink -f $2)"
else
mp="$2"
fi
# This bash glyph simply removes a trailing slash
# if one exists. /a/b/ -> /a/b; /a/b -> /a/b.
mp="${mp%/}"
poss_mp=$(real_mountpoint "$dev" "$mp")
ret=$?
if [ $ret -eq $YES ] && [ -n "$poss_mp" ]; then
# if we made it here, then the device is mounted, but not where
# we expected it to be
case $OCF_RESKEY_fstype in
cifs|nfs|nfs4)
ret=$NO
;;
*)
ocf_log warn "Device $dev is mounted on $poss_mp instead of $mp"
;;
esac
fi
return $ret
}
#
# is_alive mount_point
#
# Check to see if mount_point is alive (testing read/write)
#
is_alive()
{
declare errcode
declare mount_point="$1"
declare file
declare rw
if [ $# -ne 1 ]; then
ocf_log err "Usage: is_alive mount_point"
return $FAIL
fi
[ -z "$OCF_CHECK_LEVEL" ] && export OCF_CHECK_LEVEL=0
test -d "$mount_point"
if [ $? -ne 0 ]; then
ocf_log err "${OCF_RESOURCE_INSTANCE}: is_alive: $mount_point is not a directory"
return $FAIL
fi
[ $OCF_CHECK_LEVEL -lt 10 ] && return $YES
# depth 10 test (read test)
ls "$mount_point" > /dev/null 2> /dev/null
errcode=$?
if [ $errcode -ne 0 ]; then
ocf_log err "${OCF_RESOURCE_INSTANCE}: is_alive: failed read test on [$mount_point]. Return code: $errcode"
return $NO
fi
[ $OCF_CHECK_LEVEL -lt 20 ] && return $YES
# depth 20 check (write test)
rw=$YES
for o in `echo $OCF_RESKEY_options | sed -e s/,/\ /g`; do
if [ "$o" = "ro" ]; then
rw=$NO
fi
done
if [ $rw -eq $YES ]; then
file=$(mktemp "$mount_point/.check_writable.$(hostname).XXXXXX")
if [ ! -e "$file" ]; then
ocf_log err "${OCF_RESOURCE_INSTANCE}: is_alive: failed write test on [$mount_point]. Return code: $errcode"
return $NO
fi
rm -f $file > /dev/null 2> /dev/null
fi
return $YES
}
#
# Decide which quota options are enabled and return a string
# which we can pass to quotaon
#
quota_opts()
{
declare quotaopts=""
declare opts="$1"
declare mopt
for mopt in `echo $opts | sed -e s/,/\ /g`; do
case $mopt in
quota)
quotaopts="gu"
break
;;
usrquota)
quotaopts="u$quotaopts"
continue
;;
grpquota)
quotaopts="g$quotaopts"
continue
;;
noquota)
quotaopts=""
return 0
;;
esac
done
echo $quotaopts
return 0
}
#
# Enable quotas on the mount point if the user requested them
#
enable_fs_quotas()
{
declare -i need_check=0
declare -i rv
declare quotaopts=""
declare mopt
declare opts="$1"
declare mp="$2"
if ! type quotaon &> /dev/null; then
ocf_log err "quotaon not found in $PATH"
return $OCF_ERR_GENERIC
fi
quotaopts=$(quota_opts $opts)
[ -z "$quotaopts" ] && return 0
ocf_log debug "quotaopts = $quotaopts"
# Ok, create quota files if they don't exist
for f in quota.user aquota.user quota.group aquota.group; do
if ! [ -f "$mp/$f" ]; then
ocf_log info "$mp/$f was missing - creating"
touch "$mp/$f"
chmod 600 "$mp/$f"
need_check=1
fi
done
if [ $need_check -eq 1 ]; then
ocf_log info "Checking quota info in $mp"
quotacheck -$quotaopts "$mp"
fi
ocf_log info "Enabling Quotas on $mp"
ocf_log debug "quotaon -$quotaopts \"$mp\""
quotaon -$quotaopts "$mp"
rv=$?
if [ $rv -ne 0 ]; then
# Just a warning
ocf_log warn "Unable to turn on quotas for $mp; return = $rv"
fi
return $rv
}
# Agent-specific actions to take before mounting
# (if required). Typically things like fsck.
do_pre_mount() {
return 0
}
# Default mount handler - for block devices
#
do_mount() {
declare dev="$1"
declare mp="$2"
declare mount_options=""
declare fstype_option=""
declare fstype
#
# Get the filesystem type, if specified.
#
fstype_option=""
fstype=${OCF_RESKEY_fstype}
case "$fstype" in
""|"[ ]*")
fstype=""
;;
*) # found it
fstype_option="-t $fstype"
;;
esac
#
# Get the mount options, if they exist.
#
mount_options=""
opts=${OCF_RESKEY_options}
case "$opts" in
""|"[ ]*")
opts=""
;;
*) # found it
mount_options="-o $opts"
;;
esac
#
# Mount the device
#
ocf_log info "mounting $dev on $mp"
ocf_log err "mount $fstype_option $mount_options $dev $mp"
mount $fstype_option $mount_options "$dev" "$mp"
ret_val=$?
if [ $ret_val -ne 0 ]; then
ocf_log err "\
'mount $fstype_option $mount_options $dev $mp' failed, error=$ret_val"
return 1
fi
return 0
}
# Agent-specific actions to take after mounting
# (if required).
do_post_mount() {
return 0
}
# Agent-specific actions to take before unmounting
# (if required)
do_pre_unmount() {
return 0
}
# Agent-specific actions to take after umount succeeds
# (if required)
do_post_unmount() {
return 0
}
# Agent-specific force unmount logic, if required
# return = 0 if successful, or nonzero if unsuccessful
# (unsuccessful = try harder)
do_force_unmount() {
return 1
}
#
# start_filesystem
#
start_filesystem() {
declare -i ret_val=$OCF_SUCCESS
declare mp="${OCF_RESKEY_mountpoint}"
declare dev="" # device
declare fstype=""
declare opts=""
declare mount_options=""
#
# Check if fstype is supported
#
verify_fstype
case $? in
$OCF_ERR_ARGS)
ocf_log err "File system type $OCF_RESKEY_fstype not supported"
return $OCF_ERR_ARGS
;;
*)
;;
esac
#
# Check if mount point was specified. If not, no need to continue.
#
case "$mp" in
""|"[ ]*") # nothing to mount
return $OCF_SUCCESS
;;
/*) # found it
;;
*) # invalid format
ocf_log err \
"start_filesystem: Invalid mount point format (must begin with a '/'): \'$mp\'"
return $OCF_ERR_ARGS
;;
esac
#
# Get the device
#
real_device "$OCF_RESKEY_device"
dev="$REAL_DEVICE"
if [ -z "$dev" ]; then
ocf_log err "\
start_filesystem: Could not match $OCF_RESKEY_device with a real device"
return $OCF_ERR_ARGS
fi
#
# Ensure we've got a valid directory
#
if [ -e "$mp" ]; then
if ! [ -d "$mp" ]; then
ocf_log err"\
start_filesystem: Mount point $mp exists but is not a directory"
return $OCF_ERR_ARGS
fi
else
ocf_log err "\
start_filesystem: Creating mount point $mp for device $dev"
mkdir -p "$mp"
ret_val=$?
if [ $ret_val -ne 0 ]; then
ocf_log err "\
start_filesystem: Unable to create $mp. Error code: $ret_val"
return $OCF_ERR_GENERIC
fi
fi
#
# See if the device is already mounted.
#
is_mounted "$dev" "$mp"
case $? in
$YES) # already mounted
ocf_log debug "$dev already mounted"
return $OCF_SUCCESS
;;
$NO) # not mounted, continue
;;
*)
return $FAIL
;;
esac
#
# Make sure that neither the device nor the mount point are mounted
# (i.e. they may be mounted in a different location). The'mount_in_use'
# function checks to see if either the device or mount point are in
# use somewhere else on the system.
#
mount_in_use "$dev" "$mp"
case $? in
$YES) # uh oh, someone is using the device or mount point
ocf_log err "\
Cannot mount $dev on $mp, the device or mount point is already in use!"
return $FAIL
;;
$NO) # good, no one else is using it
;;
$FAIL)
return $FAIL
;;
*)
ocf_log err "Unknown return from mount_in_use"
return $FAIL
;;
esac
do_pre_mount
case $? in
0)
;;
1)
return $OCF_ERR_GENERIC
;;
2)
return $OCF_SUCCESS
;;
esac
do_mount "$dev" "$mp"
case $? in
0)
;;
1)
return $OCF_ERR_GENERIC
;;
2)
return $OCF_SUCCESS
;;
esac
do_post_mount
case $? in
0)
;;
1)
return $OCF_ERR_GENERIC
;;
2)
return $OCF_SUCCESS
;;
esac
enable_fs_quotas "$opts" "$mp"
return $OCF_SUCCESS
}
#
# stop_filesystem - unmount a file system; calls out to
#
stop_filesystem() {
declare -i ret_val=0
declare -i try
declare -i sleep_time=5 # time between each umount failure
declare umount_failed=""
declare force_umount=""
declare self_fence=""
declare quotaopts=""
#
# Get the mount point, if it exists. If not, no need to continue.
#
mp=${OCF_RESKEY_mountpoint}
case "$mp" in
""|"[ ]*") # nothing to mount
return $OCF_SUCCESS
;;
/*) # found it
;;
*) # invalid format
ocf_log err \
"stop_filesystem: Invalid mount point format (must begin with a '/'): \'$mp\'"
return $FAIL
;;
esac
#
# Get the device
#
real_device "$OCF_RESKEY_device"
dev="$REAL_DEVICE"
if [ -z "$dev" ]; then
ocf_log err "\
stop: Could not match $OCF_RESKEY_device with a real device"
return $OCF_ERR_INSTALLED
fi
#
# Get the force unmount setting if there is a mount point.
#
case ${OCF_RESKEY_force_unmount} in
$YES_STR) force_umount=$YES ;;
on) force_umount=$YES ;;
true) force_umount=$YES ;;
1) force_umount=$YES ;;
*) force_umount="" ;;
esac
#
# self_fence _MUST_ be initialized before calling do_pre_unmount
# The netfs agent depends on the self_fence variable.
#
case ${OCF_RESKEY_self_fence} in
$YES_STR) self_fence=$YES ;;
on) self_fence=$YES ;;
true) self_fence=$YES ;;
1) self_fence=$YES ;;
*) self_fence="" ;;
esac
do_pre_unmount
case $? in
0)
;;
1)
return $OCF_ERR_GENERIC
;;
2)
return $OCF_SUCCESS
;;
esac
#
# Preparations: sync, turn off quotas
#
sync
quotaopts=$(quota_opts $OCF_RESKEY_options)
if [ -n "$quotaopts" ]; then
ocf_log debug "Turning off quotas for $mp"
quotaoff -$quotaopts "$mp" &> /dev/null
fi
#
# Unmount the device.
#
for try in 1 2 3; do
if [ $try -ne 1 ]; then
sleep $sleep_time
fi
is_mounted "$dev" "$mp"
case $? in
$NO)
ocf_log info "$dev is not mounted"
umount_failed=
break
;;
$YES) # fallthrough
;;
*)
return $FAIL
;;
esac
case ${OCF_RESKEY_no_unmount} in
yes|YES|true|TRUE|YES|on|ON|1)
ocf_log debug "Skipping umount on stop because of 'no_unmount' option"
return $OCF_SUCCESS
;;
*) : ;;
esac
ocf_log info "unmounting $mp"
umount "$mp"
ret_val=$?
# some versions of umount will exit with status 16 iff
# the umount(2) succeeded but /etc/mtab could not be written.
if [ $ret_val -eq 0 -o $ret_val -eq 16 ]; then
umount_failed=
break
fi
ocf_log debug "umount failed: $ret_val"
umount_failed=yes
if [ -z "$force_umount" ]; then
continue
fi
# Force unmount: try #1: send SIGTERM
if [ $try -eq 1 ]; then
# Try fs-specific force unmount, if provided
do_force_unmount
if [ $? -eq 0 ]; then
# if this succeeds, we should be done
continue
fi
ocf_log warning "Sending SIGTERM to processes on $mp"
kill_procs_using_mount "$mp" "TERM"
continue
else
ocf_log warning "Sending SIGKILL to processes on $mp"
kill_procs_using_mount "$mp"
if [ $? -eq 0 ]; then
# someone is still accessing the mount, We've already sent
# SIGTERM, now we've sent SIGKILL and are trying umount again.
continue
fi
# mount has failed, and no one is accessing it. There's
# nothing left for us to try.
break
fi
done # for
do_post_unmount
case $? in
0)
;;
1)
return $OCF_ERR_GENERIC
;;
2)
return $OCF_SUCCESS
;;
esac
if [ -n "$umount_failed" ]; then
ocf_log err "'umount $mp' failed, error=$ret_val"
if [ "$self_fence" ]; then
ocf_log alert "umount failed - REBOOTING"
sync
reboot -fn
fi
return $OCF_ERR_GENERIC
fi
return $OCF_SUCCESS
}
do_start() {
declare tries=0
declare rv
while [ $tries -lt 3 ]; do
start_filesystem
rv=$?
if [ $rv -eq 0 ]; then
return 0
fi
((tries++))
sleep 3
done
return $rv
}
do_stop() {
stop_filesystem
return $?
}
do_monitor() {
ocf_log debug "Checking fs \"$OCF_RESKEY_name\", Level $OCF_CHECK_LEVEL"
#
# Get the device
#
real_device "$OCF_RESKEY_device"
dev="$REAL_DEVICE"
if [ -z "$dev" ]; then
ocf_log err "\
start_filesystem: Could not match $OCF_RESKEY_device with a real device"
return $OCF_NOT_RUNNING
fi
is_mounted "$dev" "${OCF_RESKEY_mountpoint}"
if [ $? -ne $YES ]; then
ocf_log err "${OCF_RESOURCE_INSTANCE}: ${OCF_RESKEY_device} is not mounted on ${OCF_RESKEY_mountpoint}"
return $OCF_NOT_RUNNING
fi
if [ "$OCF_RESKEY_quick_status" = "1" ]; then
return 0
fi
is_alive "${OCF_RESKEY_mountpoint}"
[ $? -eq $YES ] && return 0
ocf_log err "fs:${OCF_RESKEY_name}: Mount point is not accessible!"
return $OCF_ERR_GENERIC
}
do_restart() {
stop_filesystem
if [ $? -ne 0 ]; then
return $OCF_ERR_GENERIC
fi
start_filesystem
if [ $? -ne 0 ]; then
return $OCF_ERR_GENERIC
fi
return 0
}
# MUST BE OVERRIDDEN
do_metadata() {
return 1
}
do_validate() {
return 1
}
main() {
case $1 in
start)
do_start
exit $?
;;
stop)
do_stop
exit $?
;;
status|monitor)
do_monitor
exit $?
;;
restart)
do_restart
exit $?
;;
meta-data)
do_metadata
exit $?
;;
validate-all)
do_validate
;;
*)
echo "usage: $0 {start|stop|status|monitor|restart|meta-data|validate-all}"
exit $OCF_ERR_UNIMPLEMENTED
;;
esac
exit 0
}
|